/***************************************************************************//**
* \file UARTdbg_PINS.h
* \version 4.0
*
* \brief
*  This file provides constants and parameter values for the pin components
*  buried into SCB Component.
*
* Note:
*
********************************************************************************
* \copyright
* Copyright 2013-2017, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_SCB_PINS_UARTdbg_H)
#define CY_SCB_PINS_UARTdbg_H

#include "cydevice_trm.h"
#include "cyfitter.h"
#include "cytypes.h"


/***************************************
*   Conditional Compilation Parameters
****************************************/

/* Unconfigured pins */
#define UARTdbg_REMOVE_RX_WAKE_SDA_MOSI_PIN  (1u)
#define UARTdbg_REMOVE_RX_SDA_MOSI_PIN      (1u)
#define UARTdbg_REMOVE_TX_SCL_MISO_PIN      (1u)
#define UARTdbg_REMOVE_CTS_SCLK_PIN      (1u)
#define UARTdbg_REMOVE_RTS_SS0_PIN      (1u)
#define UARTdbg_REMOVE_SS1_PIN                 (1u)
#define UARTdbg_REMOVE_SS2_PIN                 (1u)
#define UARTdbg_REMOVE_SS3_PIN                 (1u)

/* Mode defined pins */
#define UARTdbg_REMOVE_I2C_PINS                (1u)
#define UARTdbg_REMOVE_SPI_MASTER_PINS         (1u)
#define UARTdbg_REMOVE_SPI_MASTER_SCLK_PIN     (1u)
#define UARTdbg_REMOVE_SPI_MASTER_MOSI_PIN     (1u)
#define UARTdbg_REMOVE_SPI_MASTER_MISO_PIN     (1u)
#define UARTdbg_REMOVE_SPI_MASTER_SS0_PIN      (1u)
#define UARTdbg_REMOVE_SPI_MASTER_SS1_PIN      (1u)
#define UARTdbg_REMOVE_SPI_MASTER_SS2_PIN      (1u)
#define UARTdbg_REMOVE_SPI_MASTER_SS3_PIN      (1u)
#define UARTdbg_REMOVE_SPI_SLAVE_PINS          (1u)
#define UARTdbg_REMOVE_SPI_SLAVE_MOSI_PIN      (1u)
#define UARTdbg_REMOVE_SPI_SLAVE_MISO_PIN      (1u)
#define UARTdbg_REMOVE_UART_TX_PIN             (0u)
#define UARTdbg_REMOVE_UART_RX_TX_PIN          (1u)
#define UARTdbg_REMOVE_UART_RX_PIN             (0u)
#define UARTdbg_REMOVE_UART_RX_WAKE_PIN        (1u)
#define UARTdbg_REMOVE_UART_RTS_PIN            (1u)
#define UARTdbg_REMOVE_UART_CTS_PIN            (1u)

/* Unconfigured pins */
#define UARTdbg_RX_WAKE_SDA_MOSI_PIN (0u == UARTdbg_REMOVE_RX_WAKE_SDA_MOSI_PIN)
#define UARTdbg_RX_SDA_MOSI_PIN     (0u == UARTdbg_REMOVE_RX_SDA_MOSI_PIN)
#define UARTdbg_TX_SCL_MISO_PIN     (0u == UARTdbg_REMOVE_TX_SCL_MISO_PIN)
#define UARTdbg_CTS_SCLK_PIN     (0u == UARTdbg_REMOVE_CTS_SCLK_PIN)
#define UARTdbg_RTS_SS0_PIN     (0u == UARTdbg_REMOVE_RTS_SS0_PIN)
#define UARTdbg_SS1_PIN                (0u == UARTdbg_REMOVE_SS1_PIN)
#define UARTdbg_SS2_PIN                (0u == UARTdbg_REMOVE_SS2_PIN)
#define UARTdbg_SS3_PIN                (0u == UARTdbg_REMOVE_SS3_PIN)

/* Mode defined pins */
#define UARTdbg_I2C_PINS               (0u == UARTdbg_REMOVE_I2C_PINS)
#define UARTdbg_SPI_MASTER_PINS        (0u == UARTdbg_REMOVE_SPI_MASTER_PINS)
#define UARTdbg_SPI_MASTER_SCLK_PIN    (0u == UARTdbg_REMOVE_SPI_MASTER_SCLK_PIN)
#define UARTdbg_SPI_MASTER_MOSI_PIN    (0u == UARTdbg_REMOVE_SPI_MASTER_MOSI_PIN)
#define UARTdbg_SPI_MASTER_MISO_PIN    (0u == UARTdbg_REMOVE_SPI_MASTER_MISO_PIN)
#define UARTdbg_SPI_MASTER_SS0_PIN     (0u == UARTdbg_REMOVE_SPI_MASTER_SS0_PIN)
#define UARTdbg_SPI_MASTER_SS1_PIN     (0u == UARTdbg_REMOVE_SPI_MASTER_SS1_PIN)
#define UARTdbg_SPI_MASTER_SS2_PIN     (0u == UARTdbg_REMOVE_SPI_MASTER_SS2_PIN)
#define UARTdbg_SPI_MASTER_SS3_PIN     (0u == UARTdbg_REMOVE_SPI_MASTER_SS3_PIN)
#define UARTdbg_SPI_SLAVE_PINS         (0u == UARTdbg_REMOVE_SPI_SLAVE_PINS)
#define UARTdbg_SPI_SLAVE_MOSI_PIN     (0u == UARTdbg_REMOVE_SPI_SLAVE_MOSI_PIN)
#define UARTdbg_SPI_SLAVE_MISO_PIN     (0u == UARTdbg_REMOVE_SPI_SLAVE_MISO_PIN)
#define UARTdbg_UART_TX_PIN            (0u == UARTdbg_REMOVE_UART_TX_PIN)
#define UARTdbg_UART_RX_TX_PIN         (0u == UARTdbg_REMOVE_UART_RX_TX_PIN)
#define UARTdbg_UART_RX_PIN            (0u == UARTdbg_REMOVE_UART_RX_PIN)
#define UARTdbg_UART_RX_WAKE_PIN       (0u == UARTdbg_REMOVE_UART_RX_WAKE_PIN)
#define UARTdbg_UART_RTS_PIN           (0u == UARTdbg_REMOVE_UART_RTS_PIN)
#define UARTdbg_UART_CTS_PIN           (0u == UARTdbg_REMOVE_UART_CTS_PIN)


/***************************************
*             Includes
****************************************/

#if (UARTdbg_RX_WAKE_SDA_MOSI_PIN)
    #include "UARTdbg_uart_rx_wake_i2c_sda_spi_mosi.h"
#endif /* (UARTdbg_RX_SDA_MOSI) */

#if (UARTdbg_RX_SDA_MOSI_PIN)
    #include "UARTdbg_uart_rx_i2c_sda_spi_mosi.h"
#endif /* (UARTdbg_RX_SDA_MOSI) */

#if (UARTdbg_TX_SCL_MISO_PIN)
    #include "UARTdbg_uart_tx_i2c_scl_spi_miso.h"
#endif /* (UARTdbg_TX_SCL_MISO) */

#if (UARTdbg_CTS_SCLK_PIN)
    #include "UARTdbg_uart_cts_spi_sclk.h"
#endif /* (UARTdbg_CTS_SCLK) */

#if (UARTdbg_RTS_SS0_PIN)
    #include "UARTdbg_uart_rts_spi_ss0.h"
#endif /* (UARTdbg_RTS_SS0_PIN) */

#if (UARTdbg_SS1_PIN)
    #include "UARTdbg_spi_ss1.h"
#endif /* (UARTdbg_SS1_PIN) */

#if (UARTdbg_SS2_PIN)
    #include "UARTdbg_spi_ss2.h"
#endif /* (UARTdbg_SS2_PIN) */

#if (UARTdbg_SS3_PIN)
    #include "UARTdbg_spi_ss3.h"
#endif /* (UARTdbg_SS3_PIN) */

#if (UARTdbg_I2C_PINS)
    #include "UARTdbg_scl.h"
    #include "UARTdbg_sda.h"
#endif /* (UARTdbg_I2C_PINS) */

#if (UARTdbg_SPI_MASTER_PINS)
#if (UARTdbg_SPI_MASTER_SCLK_PIN)
    #include "UARTdbg_sclk_m.h"
#endif /* (UARTdbg_SPI_MASTER_SCLK_PIN) */

#if (UARTdbg_SPI_MASTER_MOSI_PIN)
    #include "UARTdbg_mosi_m.h"
#endif /* (UARTdbg_SPI_MASTER_MOSI_PIN) */

#if (UARTdbg_SPI_MASTER_MISO_PIN)
    #include "UARTdbg_miso_m.h"
#endif /*(UARTdbg_SPI_MASTER_MISO_PIN) */
#endif /* (UARTdbg_SPI_MASTER_PINS) */

#if (UARTdbg_SPI_SLAVE_PINS)
    #include "UARTdbg_sclk_s.h"
    #include "UARTdbg_ss_s.h"

#if (UARTdbg_SPI_SLAVE_MOSI_PIN)
    #include "UARTdbg_mosi_s.h"
#endif /* (UARTdbg_SPI_SLAVE_MOSI_PIN) */

#if (UARTdbg_SPI_SLAVE_MISO_PIN)
    #include "UARTdbg_miso_s.h"
#endif /*(UARTdbg_SPI_SLAVE_MISO_PIN) */
#endif /* (UARTdbg_SPI_SLAVE_PINS) */

#if (UARTdbg_SPI_MASTER_SS0_PIN)
    #include "UARTdbg_ss0_m.h"
#endif /* (UARTdbg_SPI_MASTER_SS0_PIN) */

#if (UARTdbg_SPI_MASTER_SS1_PIN)
    #include "UARTdbg_ss1_m.h"
#endif /* (UARTdbg_SPI_MASTER_SS1_PIN) */

#if (UARTdbg_SPI_MASTER_SS2_PIN)
    #include "UARTdbg_ss2_m.h"
#endif /* (UARTdbg_SPI_MASTER_SS2_PIN) */

#if (UARTdbg_SPI_MASTER_SS3_PIN)
    #include "UARTdbg_ss3_m.h"
#endif /* (UARTdbg_SPI_MASTER_SS3_PIN) */

#if (UARTdbg_UART_TX_PIN)
    #include "UARTdbg_tx.h"
#endif /* (UARTdbg_UART_TX_PIN) */

#if (UARTdbg_UART_RX_TX_PIN)
    #include "UARTdbg_rx_tx.h"
#endif /* (UARTdbg_UART_RX_TX_PIN) */

#if (UARTdbg_UART_RX_PIN)
    #include "UARTdbg_rx.h"
#endif /* (UARTdbg_UART_RX_PIN) */

#if (UARTdbg_UART_RX_WAKE_PIN)
    #include "UARTdbg_rx_wake.h"
#endif /* (UARTdbg_UART_RX_WAKE_PIN) */

#if (UARTdbg_UART_RTS_PIN)
    #include "UARTdbg_rts.h"
#endif /* (UARTdbg_UART_RTS_PIN) */

#if (UARTdbg_UART_CTS_PIN)
    #include "UARTdbg_cts.h"
#endif /* (UARTdbg_UART_CTS_PIN) */


/***************************************
*              Registers
***************************************/

#if (UARTdbg_RX_SDA_MOSI_PIN)
    #define UARTdbg_RX_SDA_MOSI_HSIOM_REG   (*(reg32 *) UARTdbg_uart_rx_i2c_sda_spi_mosi__0__HSIOM)
    #define UARTdbg_RX_SDA_MOSI_HSIOM_PTR   ( (reg32 *) UARTdbg_uart_rx_i2c_sda_spi_mosi__0__HSIOM)
    
    #define UARTdbg_RX_SDA_MOSI_HSIOM_MASK      (UARTdbg_uart_rx_i2c_sda_spi_mosi__0__HSIOM_MASK)
    #define UARTdbg_RX_SDA_MOSI_HSIOM_POS       (UARTdbg_uart_rx_i2c_sda_spi_mosi__0__HSIOM_SHIFT)
    #define UARTdbg_RX_SDA_MOSI_HSIOM_SEL_GPIO  (UARTdbg_uart_rx_i2c_sda_spi_mosi__0__HSIOM_GPIO)
    #define UARTdbg_RX_SDA_MOSI_HSIOM_SEL_I2C   (UARTdbg_uart_rx_i2c_sda_spi_mosi__0__HSIOM_I2C)
    #define UARTdbg_RX_SDA_MOSI_HSIOM_SEL_SPI   (UARTdbg_uart_rx_i2c_sda_spi_mosi__0__HSIOM_SPI)
    #define UARTdbg_RX_SDA_MOSI_HSIOM_SEL_UART  (UARTdbg_uart_rx_i2c_sda_spi_mosi__0__HSIOM_UART)
    
#elif (UARTdbg_RX_WAKE_SDA_MOSI_PIN)
    #define UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_REG   (*(reg32 *) UARTdbg_uart_rx_wake_i2c_sda_spi_mosi__0__HSIOM)
    #define UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_PTR   ( (reg32 *) UARTdbg_uart_rx_wake_i2c_sda_spi_mosi__0__HSIOM)
    
    #define UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_MASK      (UARTdbg_uart_rx_wake_i2c_sda_spi_mosi__0__HSIOM_MASK)
    #define UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_POS       (UARTdbg_uart_rx_wake_i2c_sda_spi_mosi__0__HSIOM_SHIFT)
    #define UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_SEL_GPIO  (UARTdbg_uart_rx_wake_i2c_sda_spi_mosi__0__HSIOM_GPIO)
    #define UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_SEL_I2C   (UARTdbg_uart_rx_wake_i2c_sda_spi_mosi__0__HSIOM_I2C)
    #define UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_SEL_SPI   (UARTdbg_uart_rx_wake_i2c_sda_spi_mosi__0__HSIOM_SPI)
    #define UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_SEL_UART  (UARTdbg_uart_rx_wake_i2c_sda_spi_mosi__0__HSIOM_UART)    
   
    #define UARTdbg_RX_WAKE_SDA_MOSI_INTCFG_REG (*(reg32 *) UARTdbg_uart_rx_wake_i2c_sda_spi_mosi__0__INTCFG)
    #define UARTdbg_RX_WAKE_SDA_MOSI_INTCFG_PTR ( (reg32 *) UARTdbg_uart_rx_wake_i2c_sda_spi_mosi__0__INTCFG)
    #define UARTdbg_RX_WAKE_SDA_MOSI_INTCFG_TYPE_POS  (UARTdbg_uart_rx_wake_i2c_sda_spi_mosi__SHIFT)
    #define UARTdbg_RX_WAKE_SDA_MOSI_INTCFG_TYPE_MASK ((uint32) UARTdbg_INTCFG_TYPE_MASK << \
                                                                           UARTdbg_RX_WAKE_SDA_MOSI_INTCFG_TYPE_POS)
#else
    /* None of pins UARTdbg_RX_SDA_MOSI_PIN or UARTdbg_RX_WAKE_SDA_MOSI_PIN present.*/
#endif /* (UARTdbg_RX_SDA_MOSI_PIN) */

#if (UARTdbg_TX_SCL_MISO_PIN)
    #define UARTdbg_TX_SCL_MISO_HSIOM_REG   (*(reg32 *) UARTdbg_uart_tx_i2c_scl_spi_miso__0__HSIOM)
    #define UARTdbg_TX_SCL_MISO_HSIOM_PTR   ( (reg32 *) UARTdbg_uart_tx_i2c_scl_spi_miso__0__HSIOM)
    
    #define UARTdbg_TX_SCL_MISO_HSIOM_MASK      (UARTdbg_uart_tx_i2c_scl_spi_miso__0__HSIOM_MASK)
    #define UARTdbg_TX_SCL_MISO_HSIOM_POS       (UARTdbg_uart_tx_i2c_scl_spi_miso__0__HSIOM_SHIFT)
    #define UARTdbg_TX_SCL_MISO_HSIOM_SEL_GPIO  (UARTdbg_uart_tx_i2c_scl_spi_miso__0__HSIOM_GPIO)
    #define UARTdbg_TX_SCL_MISO_HSIOM_SEL_I2C   (UARTdbg_uart_tx_i2c_scl_spi_miso__0__HSIOM_I2C)
    #define UARTdbg_TX_SCL_MISO_HSIOM_SEL_SPI   (UARTdbg_uart_tx_i2c_scl_spi_miso__0__HSIOM_SPI)
    #define UARTdbg_TX_SCL_MISO_HSIOM_SEL_UART  (UARTdbg_uart_tx_i2c_scl_spi_miso__0__HSIOM_UART)
#endif /* (UARTdbg_TX_SCL_MISO_PIN) */

#if (UARTdbg_CTS_SCLK_PIN)
    #define UARTdbg_CTS_SCLK_HSIOM_REG   (*(reg32 *) UARTdbg_uart_cts_spi_sclk__0__HSIOM)
    #define UARTdbg_CTS_SCLK_HSIOM_PTR   ( (reg32 *) UARTdbg_uart_cts_spi_sclk__0__HSIOM)
    
    #define UARTdbg_CTS_SCLK_HSIOM_MASK      (UARTdbg_uart_cts_spi_sclk__0__HSIOM_MASK)
    #define UARTdbg_CTS_SCLK_HSIOM_POS       (UARTdbg_uart_cts_spi_sclk__0__HSIOM_SHIFT)
    #define UARTdbg_CTS_SCLK_HSIOM_SEL_GPIO  (UARTdbg_uart_cts_spi_sclk__0__HSIOM_GPIO)
    #define UARTdbg_CTS_SCLK_HSIOM_SEL_I2C   (UARTdbg_uart_cts_spi_sclk__0__HSIOM_I2C)
    #define UARTdbg_CTS_SCLK_HSIOM_SEL_SPI   (UARTdbg_uart_cts_spi_sclk__0__HSIOM_SPI)
    #define UARTdbg_CTS_SCLK_HSIOM_SEL_UART  (UARTdbg_uart_cts_spi_sclk__0__HSIOM_UART)
#endif /* (UARTdbg_CTS_SCLK_PIN) */

#if (UARTdbg_RTS_SS0_PIN)
    #define UARTdbg_RTS_SS0_HSIOM_REG   (*(reg32 *) UARTdbg_uart_rts_spi_ss0__0__HSIOM)
    #define UARTdbg_RTS_SS0_HSIOM_PTR   ( (reg32 *) UARTdbg_uart_rts_spi_ss0__0__HSIOM)
    
    #define UARTdbg_RTS_SS0_HSIOM_MASK      (UARTdbg_uart_rts_spi_ss0__0__HSIOM_MASK)
    #define UARTdbg_RTS_SS0_HSIOM_POS       (UARTdbg_uart_rts_spi_ss0__0__HSIOM_SHIFT)
    #define UARTdbg_RTS_SS0_HSIOM_SEL_GPIO  (UARTdbg_uart_rts_spi_ss0__0__HSIOM_GPIO)
    #define UARTdbg_RTS_SS0_HSIOM_SEL_I2C   (UARTdbg_uart_rts_spi_ss0__0__HSIOM_I2C)
    #define UARTdbg_RTS_SS0_HSIOM_SEL_SPI   (UARTdbg_uart_rts_spi_ss0__0__HSIOM_SPI)
#if !(UARTdbg_CY_SCBIP_V0 || UARTdbg_CY_SCBIP_V1)
    #define UARTdbg_RTS_SS0_HSIOM_SEL_UART  (UARTdbg_uart_rts_spi_ss0__0__HSIOM_UART)
#endif /* !(UARTdbg_CY_SCBIP_V0 || UARTdbg_CY_SCBIP_V1) */
#endif /* (UARTdbg_RTS_SS0_PIN) */

#if (UARTdbg_SS1_PIN)
    #define UARTdbg_SS1_HSIOM_REG  (*(reg32 *) UARTdbg_spi_ss1__0__HSIOM)
    #define UARTdbg_SS1_HSIOM_PTR  ( (reg32 *) UARTdbg_spi_ss1__0__HSIOM)
    
    #define UARTdbg_SS1_HSIOM_MASK     (UARTdbg_spi_ss1__0__HSIOM_MASK)
    #define UARTdbg_SS1_HSIOM_POS      (UARTdbg_spi_ss1__0__HSIOM_SHIFT)
    #define UARTdbg_SS1_HSIOM_SEL_GPIO (UARTdbg_spi_ss1__0__HSIOM_GPIO)
    #define UARTdbg_SS1_HSIOM_SEL_I2C  (UARTdbg_spi_ss1__0__HSIOM_I2C)
    #define UARTdbg_SS1_HSIOM_SEL_SPI  (UARTdbg_spi_ss1__0__HSIOM_SPI)
#endif /* (UARTdbg_SS1_PIN) */

#if (UARTdbg_SS2_PIN)
    #define UARTdbg_SS2_HSIOM_REG     (*(reg32 *) UARTdbg_spi_ss2__0__HSIOM)
    #define UARTdbg_SS2_HSIOM_PTR     ( (reg32 *) UARTdbg_spi_ss2__0__HSIOM)
    
    #define UARTdbg_SS2_HSIOM_MASK     (UARTdbg_spi_ss2__0__HSIOM_MASK)
    #define UARTdbg_SS2_HSIOM_POS      (UARTdbg_spi_ss2__0__HSIOM_SHIFT)
    #define UARTdbg_SS2_HSIOM_SEL_GPIO (UARTdbg_spi_ss2__0__HSIOM_GPIO)
    #define UARTdbg_SS2_HSIOM_SEL_I2C  (UARTdbg_spi_ss2__0__HSIOM_I2C)
    #define UARTdbg_SS2_HSIOM_SEL_SPI  (UARTdbg_spi_ss2__0__HSIOM_SPI)
#endif /* (UARTdbg_SS2_PIN) */

#if (UARTdbg_SS3_PIN)
    #define UARTdbg_SS3_HSIOM_REG     (*(reg32 *) UARTdbg_spi_ss3__0__HSIOM)
    #define UARTdbg_SS3_HSIOM_PTR     ( (reg32 *) UARTdbg_spi_ss3__0__HSIOM)
    
    #define UARTdbg_SS3_HSIOM_MASK     (UARTdbg_spi_ss3__0__HSIOM_MASK)
    #define UARTdbg_SS3_HSIOM_POS      (UARTdbg_spi_ss3__0__HSIOM_SHIFT)
    #define UARTdbg_SS3_HSIOM_SEL_GPIO (UARTdbg_spi_ss3__0__HSIOM_GPIO)
    #define UARTdbg_SS3_HSIOM_SEL_I2C  (UARTdbg_spi_ss3__0__HSIOM_I2C)
    #define UARTdbg_SS3_HSIOM_SEL_SPI  (UARTdbg_spi_ss3__0__HSIOM_SPI)
#endif /* (UARTdbg_SS3_PIN) */

#if (UARTdbg_I2C_PINS)
    #define UARTdbg_SCL_HSIOM_REG  (*(reg32 *) UARTdbg_scl__0__HSIOM)
    #define UARTdbg_SCL_HSIOM_PTR  ( (reg32 *) UARTdbg_scl__0__HSIOM)
    
    #define UARTdbg_SCL_HSIOM_MASK     (UARTdbg_scl__0__HSIOM_MASK)
    #define UARTdbg_SCL_HSIOM_POS      (UARTdbg_scl__0__HSIOM_SHIFT)
    #define UARTdbg_SCL_HSIOM_SEL_GPIO (UARTdbg_sda__0__HSIOM_GPIO)
    #define UARTdbg_SCL_HSIOM_SEL_I2C  (UARTdbg_sda__0__HSIOM_I2C)
    
    #define UARTdbg_SDA_HSIOM_REG  (*(reg32 *) UARTdbg_sda__0__HSIOM)
    #define UARTdbg_SDA_HSIOM_PTR  ( (reg32 *) UARTdbg_sda__0__HSIOM)
    
    #define UARTdbg_SDA_HSIOM_MASK     (UARTdbg_sda__0__HSIOM_MASK)
    #define UARTdbg_SDA_HSIOM_POS      (UARTdbg_sda__0__HSIOM_SHIFT)
    #define UARTdbg_SDA_HSIOM_SEL_GPIO (UARTdbg_sda__0__HSIOM_GPIO)
    #define UARTdbg_SDA_HSIOM_SEL_I2C  (UARTdbg_sda__0__HSIOM_I2C)
#endif /* (UARTdbg_I2C_PINS) */

#if (UARTdbg_SPI_SLAVE_PINS)
    #define UARTdbg_SCLK_S_HSIOM_REG   (*(reg32 *) UARTdbg_sclk_s__0__HSIOM)
    #define UARTdbg_SCLK_S_HSIOM_PTR   ( (reg32 *) UARTdbg_sclk_s__0__HSIOM)
    
    #define UARTdbg_SCLK_S_HSIOM_MASK      (UARTdbg_sclk_s__0__HSIOM_MASK)
    #define UARTdbg_SCLK_S_HSIOM_POS       (UARTdbg_sclk_s__0__HSIOM_SHIFT)
    #define UARTdbg_SCLK_S_HSIOM_SEL_GPIO  (UARTdbg_sclk_s__0__HSIOM_GPIO)
    #define UARTdbg_SCLK_S_HSIOM_SEL_SPI   (UARTdbg_sclk_s__0__HSIOM_SPI)
    
    #define UARTdbg_SS0_S_HSIOM_REG    (*(reg32 *) UARTdbg_ss0_s__0__HSIOM)
    #define UARTdbg_SS0_S_HSIOM_PTR    ( (reg32 *) UARTdbg_ss0_s__0__HSIOM)
    
    #define UARTdbg_SS0_S_HSIOM_MASK       (UARTdbg_ss0_s__0__HSIOM_MASK)
    #define UARTdbg_SS0_S_HSIOM_POS        (UARTdbg_ss0_s__0__HSIOM_SHIFT)
    #define UARTdbg_SS0_S_HSIOM_SEL_GPIO   (UARTdbg_ss0_s__0__HSIOM_GPIO)  
    #define UARTdbg_SS0_S_HSIOM_SEL_SPI    (UARTdbg_ss0_s__0__HSIOM_SPI)
#endif /* (UARTdbg_SPI_SLAVE_PINS) */

#if (UARTdbg_SPI_SLAVE_MOSI_PIN)
    #define UARTdbg_MOSI_S_HSIOM_REG   (*(reg32 *) UARTdbg_mosi_s__0__HSIOM)
    #define UARTdbg_MOSI_S_HSIOM_PTR   ( (reg32 *) UARTdbg_mosi_s__0__HSIOM)
    
    #define UARTdbg_MOSI_S_HSIOM_MASK      (UARTdbg_mosi_s__0__HSIOM_MASK)
    #define UARTdbg_MOSI_S_HSIOM_POS       (UARTdbg_mosi_s__0__HSIOM_SHIFT)
    #define UARTdbg_MOSI_S_HSIOM_SEL_GPIO  (UARTdbg_mosi_s__0__HSIOM_GPIO)
    #define UARTdbg_MOSI_S_HSIOM_SEL_SPI   (UARTdbg_mosi_s__0__HSIOM_SPI)
#endif /* (UARTdbg_SPI_SLAVE_MOSI_PIN) */

#if (UARTdbg_SPI_SLAVE_MISO_PIN)
    #define UARTdbg_MISO_S_HSIOM_REG   (*(reg32 *) UARTdbg_miso_s__0__HSIOM)
    #define UARTdbg_MISO_S_HSIOM_PTR   ( (reg32 *) UARTdbg_miso_s__0__HSIOM)
    
    #define UARTdbg_MISO_S_HSIOM_MASK      (UARTdbg_miso_s__0__HSIOM_MASK)
    #define UARTdbg_MISO_S_HSIOM_POS       (UARTdbg_miso_s__0__HSIOM_SHIFT)
    #define UARTdbg_MISO_S_HSIOM_SEL_GPIO  (UARTdbg_miso_s__0__HSIOM_GPIO)
    #define UARTdbg_MISO_S_HSIOM_SEL_SPI   (UARTdbg_miso_s__0__HSIOM_SPI)
#endif /* (UARTdbg_SPI_SLAVE_MISO_PIN) */

#if (UARTdbg_SPI_MASTER_MISO_PIN)
    #define UARTdbg_MISO_M_HSIOM_REG   (*(reg32 *) UARTdbg_miso_m__0__HSIOM)
    #define UARTdbg_MISO_M_HSIOM_PTR   ( (reg32 *) UARTdbg_miso_m__0__HSIOM)
    
    #define UARTdbg_MISO_M_HSIOM_MASK      (UARTdbg_miso_m__0__HSIOM_MASK)
    #define UARTdbg_MISO_M_HSIOM_POS       (UARTdbg_miso_m__0__HSIOM_SHIFT)
    #define UARTdbg_MISO_M_HSIOM_SEL_GPIO  (UARTdbg_miso_m__0__HSIOM_GPIO)
    #define UARTdbg_MISO_M_HSIOM_SEL_SPI   (UARTdbg_miso_m__0__HSIOM_SPI)
#endif /* (UARTdbg_SPI_MASTER_MISO_PIN) */

#if (UARTdbg_SPI_MASTER_MOSI_PIN)
    #define UARTdbg_MOSI_M_HSIOM_REG   (*(reg32 *) UARTdbg_mosi_m__0__HSIOM)
    #define UARTdbg_MOSI_M_HSIOM_PTR   ( (reg32 *) UARTdbg_mosi_m__0__HSIOM)
    
    #define UARTdbg_MOSI_M_HSIOM_MASK      (UARTdbg_mosi_m__0__HSIOM_MASK)
    #define UARTdbg_MOSI_M_HSIOM_POS       (UARTdbg_mosi_m__0__HSIOM_SHIFT)
    #define UARTdbg_MOSI_M_HSIOM_SEL_GPIO  (UARTdbg_mosi_m__0__HSIOM_GPIO)
    #define UARTdbg_MOSI_M_HSIOM_SEL_SPI   (UARTdbg_mosi_m__0__HSIOM_SPI)
#endif /* (UARTdbg_SPI_MASTER_MOSI_PIN) */

#if (UARTdbg_SPI_MASTER_SCLK_PIN)
    #define UARTdbg_SCLK_M_HSIOM_REG   (*(reg32 *) UARTdbg_sclk_m__0__HSIOM)
    #define UARTdbg_SCLK_M_HSIOM_PTR   ( (reg32 *) UARTdbg_sclk_m__0__HSIOM)
    
    #define UARTdbg_SCLK_M_HSIOM_MASK      (UARTdbg_sclk_m__0__HSIOM_MASK)
    #define UARTdbg_SCLK_M_HSIOM_POS       (UARTdbg_sclk_m__0__HSIOM_SHIFT)
    #define UARTdbg_SCLK_M_HSIOM_SEL_GPIO  (UARTdbg_sclk_m__0__HSIOM_GPIO)
    #define UARTdbg_SCLK_M_HSIOM_SEL_SPI   (UARTdbg_sclk_m__0__HSIOM_SPI)
#endif /* (UARTdbg_SPI_MASTER_SCLK_PIN) */

#if (UARTdbg_SPI_MASTER_SS0_PIN)
    #define UARTdbg_SS0_M_HSIOM_REG    (*(reg32 *) UARTdbg_ss0_m__0__HSIOM)
    #define UARTdbg_SS0_M_HSIOM_PTR    ( (reg32 *) UARTdbg_ss0_m__0__HSIOM)
    
    #define UARTdbg_SS0_M_HSIOM_MASK       (UARTdbg_ss0_m__0__HSIOM_MASK)
    #define UARTdbg_SS0_M_HSIOM_POS        (UARTdbg_ss0_m__0__HSIOM_SHIFT)
    #define UARTdbg_SS0_M_HSIOM_SEL_GPIO   (UARTdbg_ss0_m__0__HSIOM_GPIO)
    #define UARTdbg_SS0_M_HSIOM_SEL_SPI    (UARTdbg_ss0_m__0__HSIOM_SPI)
#endif /* (UARTdbg_SPI_MASTER_SS0_PIN) */

#if (UARTdbg_SPI_MASTER_SS1_PIN)
    #define UARTdbg_SS1_M_HSIOM_REG    (*(reg32 *) UARTdbg_ss1_m__0__HSIOM)
    #define UARTdbg_SS1_M_HSIOM_PTR    ( (reg32 *) UARTdbg_ss1_m__0__HSIOM)
    
    #define UARTdbg_SS1_M_HSIOM_MASK       (UARTdbg_ss1_m__0__HSIOM_MASK)
    #define UARTdbg_SS1_M_HSIOM_POS        (UARTdbg_ss1_m__0__HSIOM_SHIFT)
    #define UARTdbg_SS1_M_HSIOM_SEL_GPIO   (UARTdbg_ss1_m__0__HSIOM_GPIO)
    #define UARTdbg_SS1_M_HSIOM_SEL_SPI    (UARTdbg_ss1_m__0__HSIOM_SPI)
#endif /* (UARTdbg_SPI_MASTER_SS1_PIN) */

#if (UARTdbg_SPI_MASTER_SS2_PIN)
    #define UARTdbg_SS2_M_HSIOM_REG    (*(reg32 *) UARTdbg_ss2_m__0__HSIOM)
    #define UARTdbg_SS2_M_HSIOM_PTR    ( (reg32 *) UARTdbg_ss2_m__0__HSIOM)
    
    #define UARTdbg_SS2_M_HSIOM_MASK       (UARTdbg_ss2_m__0__HSIOM_MASK)
    #define UARTdbg_SS2_M_HSIOM_POS        (UARTdbg_ss2_m__0__HSIOM_SHIFT)
    #define UARTdbg_SS2_M_HSIOM_SEL_GPIO   (UARTdbg_ss2_m__0__HSIOM_GPIO)
    #define UARTdbg_SS2_M_HSIOM_SEL_SPI    (UARTdbg_ss2_m__0__HSIOM_SPI)
#endif /* (UARTdbg_SPI_MASTER_SS2_PIN) */

#if (UARTdbg_SPI_MASTER_SS3_PIN)
    #define UARTdbg_SS3_M_HSIOM_REG    (*(reg32 *) UARTdbg_ss3_m__0__HSIOM)
    #define UARTdbg_SS3_M_HSIOM_PTR    ( (reg32 *) UARTdbg_ss3_m__0__HSIOM)
    
    #define UARTdbg_SS3_M_HSIOM_MASK      (UARTdbg_ss3_m__0__HSIOM_MASK)
    #define UARTdbg_SS3_M_HSIOM_POS       (UARTdbg_ss3_m__0__HSIOM_SHIFT)
    #define UARTdbg_SS3_M_HSIOM_SEL_GPIO  (UARTdbg_ss3_m__0__HSIOM_GPIO)
    #define UARTdbg_SS3_M_HSIOM_SEL_SPI   (UARTdbg_ss3_m__0__HSIOM_SPI)
#endif /* (UARTdbg_SPI_MASTER_SS3_PIN) */

#if (UARTdbg_UART_RX_PIN)
    #define UARTdbg_RX_HSIOM_REG   (*(reg32 *) UARTdbg_rx__0__HSIOM)
    #define UARTdbg_RX_HSIOM_PTR   ( (reg32 *) UARTdbg_rx__0__HSIOM)
    
    #define UARTdbg_RX_HSIOM_MASK      (UARTdbg_rx__0__HSIOM_MASK)
    #define UARTdbg_RX_HSIOM_POS       (UARTdbg_rx__0__HSIOM_SHIFT)
    #define UARTdbg_RX_HSIOM_SEL_GPIO  (UARTdbg_rx__0__HSIOM_GPIO)
    #define UARTdbg_RX_HSIOM_SEL_UART  (UARTdbg_rx__0__HSIOM_UART)
#endif /* (UARTdbg_UART_RX_PIN) */

#if (UARTdbg_UART_RX_WAKE_PIN)
    #define UARTdbg_RX_WAKE_HSIOM_REG   (*(reg32 *) UARTdbg_rx_wake__0__HSIOM)
    #define UARTdbg_RX_WAKE_HSIOM_PTR   ( (reg32 *) UARTdbg_rx_wake__0__HSIOM)
    
    #define UARTdbg_RX_WAKE_HSIOM_MASK      (UARTdbg_rx_wake__0__HSIOM_MASK)
    #define UARTdbg_RX_WAKE_HSIOM_POS       (UARTdbg_rx_wake__0__HSIOM_SHIFT)
    #define UARTdbg_RX_WAKE_HSIOM_SEL_GPIO  (UARTdbg_rx_wake__0__HSIOM_GPIO)
    #define UARTdbg_RX_WAKE_HSIOM_SEL_UART  (UARTdbg_rx_wake__0__HSIOM_UART)
#endif /* (UARTdbg_UART_WAKE_RX_PIN) */

#if (UARTdbg_UART_CTS_PIN)
    #define UARTdbg_CTS_HSIOM_REG   (*(reg32 *) UARTdbg_cts__0__HSIOM)
    #define UARTdbg_CTS_HSIOM_PTR   ( (reg32 *) UARTdbg_cts__0__HSIOM)
    
    #define UARTdbg_CTS_HSIOM_MASK      (UARTdbg_cts__0__HSIOM_MASK)
    #define UARTdbg_CTS_HSIOM_POS       (UARTdbg_cts__0__HSIOM_SHIFT)
    #define UARTdbg_CTS_HSIOM_SEL_GPIO  (UARTdbg_cts__0__HSIOM_GPIO)
    #define UARTdbg_CTS_HSIOM_SEL_UART  (UARTdbg_cts__0__HSIOM_UART)
#endif /* (UARTdbg_UART_CTS_PIN) */

#if (UARTdbg_UART_TX_PIN)
    #define UARTdbg_TX_HSIOM_REG   (*(reg32 *) UARTdbg_tx__0__HSIOM)
    #define UARTdbg_TX_HSIOM_PTR   ( (reg32 *) UARTdbg_tx__0__HSIOM)
    
    #define UARTdbg_TX_HSIOM_MASK      (UARTdbg_tx__0__HSIOM_MASK)
    #define UARTdbg_TX_HSIOM_POS       (UARTdbg_tx__0__HSIOM_SHIFT)
    #define UARTdbg_TX_HSIOM_SEL_GPIO  (UARTdbg_tx__0__HSIOM_GPIO)
    #define UARTdbg_TX_HSIOM_SEL_UART  (UARTdbg_tx__0__HSIOM_UART)
#endif /* (UARTdbg_UART_TX_PIN) */

#if (UARTdbg_UART_RX_TX_PIN)
    #define UARTdbg_RX_TX_HSIOM_REG   (*(reg32 *) UARTdbg_rx_tx__0__HSIOM)
    #define UARTdbg_RX_TX_HSIOM_PTR   ( (reg32 *) UARTdbg_rx_tx__0__HSIOM)
    
    #define UARTdbg_RX_TX_HSIOM_MASK      (UARTdbg_rx_tx__0__HSIOM_MASK)
    #define UARTdbg_RX_TX_HSIOM_POS       (UARTdbg_rx_tx__0__HSIOM_SHIFT)
    #define UARTdbg_RX_TX_HSIOM_SEL_GPIO  (UARTdbg_rx_tx__0__HSIOM_GPIO)
    #define UARTdbg_RX_TX_HSIOM_SEL_UART  (UARTdbg_rx_tx__0__HSIOM_UART)
#endif /* (UARTdbg_UART_RX_TX_PIN) */

#if (UARTdbg_UART_RTS_PIN)
    #define UARTdbg_RTS_HSIOM_REG      (*(reg32 *) UARTdbg_rts__0__HSIOM)
    #define UARTdbg_RTS_HSIOM_PTR      ( (reg32 *) UARTdbg_rts__0__HSIOM)
    
    #define UARTdbg_RTS_HSIOM_MASK     (UARTdbg_rts__0__HSIOM_MASK)
    #define UARTdbg_RTS_HSIOM_POS      (UARTdbg_rts__0__HSIOM_SHIFT)    
    #define UARTdbg_RTS_HSIOM_SEL_GPIO (UARTdbg_rts__0__HSIOM_GPIO)
    #define UARTdbg_RTS_HSIOM_SEL_UART (UARTdbg_rts__0__HSIOM_UART)    
#endif /* (UARTdbg_UART_RTS_PIN) */


/***************************************
*        Registers Constants
***************************************/

/* HSIOM switch values. */ 
#define UARTdbg_HSIOM_DEF_SEL      (0x00u)
#define UARTdbg_HSIOM_GPIO_SEL     (0x00u)
/* The HSIOM values provided below are valid only for UARTdbg_CY_SCBIP_V0 
* and UARTdbg_CY_SCBIP_V1. It is not recommended to use them for 
* UARTdbg_CY_SCBIP_V2. Use pin name specific HSIOM constants provided 
* above instead for any SCB IP block version.
*/
#define UARTdbg_HSIOM_UART_SEL     (0x09u)
#define UARTdbg_HSIOM_I2C_SEL      (0x0Eu)
#define UARTdbg_HSIOM_SPI_SEL      (0x0Fu)

/* Pins settings index. */
#define UARTdbg_RX_WAKE_SDA_MOSI_PIN_INDEX   (0u)
#define UARTdbg_RX_SDA_MOSI_PIN_INDEX       (0u)
#define UARTdbg_TX_SCL_MISO_PIN_INDEX       (1u)
#define UARTdbg_CTS_SCLK_PIN_INDEX       (2u)
#define UARTdbg_RTS_SS0_PIN_INDEX       (3u)
#define UARTdbg_SS1_PIN_INDEX                  (4u)
#define UARTdbg_SS2_PIN_INDEX                  (5u)
#define UARTdbg_SS3_PIN_INDEX                  (6u)

/* Pins settings mask. */
#define UARTdbg_RX_WAKE_SDA_MOSI_PIN_MASK ((uint32) 0x01u << UARTdbg_RX_WAKE_SDA_MOSI_PIN_INDEX)
#define UARTdbg_RX_SDA_MOSI_PIN_MASK     ((uint32) 0x01u << UARTdbg_RX_SDA_MOSI_PIN_INDEX)
#define UARTdbg_TX_SCL_MISO_PIN_MASK     ((uint32) 0x01u << UARTdbg_TX_SCL_MISO_PIN_INDEX)
#define UARTdbg_CTS_SCLK_PIN_MASK     ((uint32) 0x01u << UARTdbg_CTS_SCLK_PIN_INDEX)
#define UARTdbg_RTS_SS0_PIN_MASK     ((uint32) 0x01u << UARTdbg_RTS_SS0_PIN_INDEX)
#define UARTdbg_SS1_PIN_MASK                ((uint32) 0x01u << UARTdbg_SS1_PIN_INDEX)
#define UARTdbg_SS2_PIN_MASK                ((uint32) 0x01u << UARTdbg_SS2_PIN_INDEX)
#define UARTdbg_SS3_PIN_MASK                ((uint32) 0x01u << UARTdbg_SS3_PIN_INDEX)

/* Pin interrupt constants. */
#define UARTdbg_INTCFG_TYPE_MASK           (0x03u)
#define UARTdbg_INTCFG_TYPE_FALLING_EDGE   (0x02u)

/* Pin Drive Mode constants. */
#define UARTdbg_PIN_DM_ALG_HIZ  (0u)
#define UARTdbg_PIN_DM_DIG_HIZ  (1u)
#define UARTdbg_PIN_DM_OD_LO    (4u)
#define UARTdbg_PIN_DM_STRONG   (6u)


/***************************************
*          Macro Definitions
***************************************/

/* Return drive mode of the pin */
#define UARTdbg_DM_MASK    (0x7u)
#define UARTdbg_DM_SIZE    (3u)
#define UARTdbg_GET_P4_PIN_DM(reg, pos) \
    ( ((reg) & (uint32) ((uint32) UARTdbg_DM_MASK << (UARTdbg_DM_SIZE * (pos)))) >> \
                                                              (UARTdbg_DM_SIZE * (pos)) )

#if (UARTdbg_TX_SCL_MISO_PIN)
    #define UARTdbg_CHECK_TX_SCL_MISO_PIN_USED \
                (UARTdbg_PIN_DM_ALG_HIZ != \
                    UARTdbg_GET_P4_PIN_DM(UARTdbg_uart_tx_i2c_scl_spi_miso_PC, \
                                                   UARTdbg_uart_tx_i2c_scl_spi_miso_SHIFT))
#endif /* (UARTdbg_TX_SCL_MISO_PIN) */

#if (UARTdbg_RTS_SS0_PIN)
    #define UARTdbg_CHECK_RTS_SS0_PIN_USED \
                (UARTdbg_PIN_DM_ALG_HIZ != \
                    UARTdbg_GET_P4_PIN_DM(UARTdbg_uart_rts_spi_ss0_PC, \
                                                   UARTdbg_uart_rts_spi_ss0_SHIFT))
#endif /* (UARTdbg_RTS_SS0_PIN) */

/* Set bits-mask in register */
#define UARTdbg_SET_REGISTER_BITS(reg, mask, pos, mode) \
                    do                                           \
                    {                                            \
                        (reg) = (((reg) & ((uint32) ~(uint32) (mask))) | ((uint32) ((uint32) (mode) << (pos)))); \
                    }while(0)

/* Set bit in the register */
#define UARTdbg_SET_REGISTER_BIT(reg, mask, val) \
                    ((val) ? ((reg) |= (mask)) : ((reg) &= ((uint32) ~((uint32) (mask)))))

#define UARTdbg_SET_HSIOM_SEL(reg, mask, pos, sel) UARTdbg_SET_REGISTER_BITS(reg, mask, pos, sel)
#define UARTdbg_SET_INCFG_TYPE(reg, mask, pos, intType) \
                                                        UARTdbg_SET_REGISTER_BITS(reg, mask, pos, intType)
#define UARTdbg_SET_INP_DIS(reg, mask, val) UARTdbg_SET_REGISTER_BIT(reg, mask, val)

/* UARTdbg_SET_I2C_SCL_DR(val) - Sets I2C SCL DR register.
*  UARTdbg_SET_I2C_SCL_HSIOM_SEL(sel) - Sets I2C SCL HSIOM settings.
*/
/* SCB I2C: scl signal */
#if (UARTdbg_CY_SCBIP_V0)
#if (UARTdbg_I2C_PINS)
    #define UARTdbg_SET_I2C_SCL_DR(val) UARTdbg_scl_Write(val)

    #define UARTdbg_SET_I2C_SCL_HSIOM_SEL(sel) \
                          UARTdbg_SET_HSIOM_SEL(UARTdbg_SCL_HSIOM_REG,  \
                                                         UARTdbg_SCL_HSIOM_MASK, \
                                                         UARTdbg_SCL_HSIOM_POS,  \
                                                         (sel))
    #define UARTdbg_WAIT_SCL_SET_HIGH  (0u == UARTdbg_scl_Read())

/* Unconfigured SCB: scl signal */
#elif (UARTdbg_RX_WAKE_SDA_MOSI_PIN)
    #define UARTdbg_SET_I2C_SCL_DR(val) \
                            UARTdbg_uart_rx_wake_i2c_sda_spi_mosi_Write(val)

    #define UARTdbg_SET_I2C_SCL_HSIOM_SEL(sel) \
                    UARTdbg_SET_HSIOM_SEL(UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_REG,  \
                                                   UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_MASK, \
                                                   UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_POS,  \
                                                   (sel))

    #define UARTdbg_WAIT_SCL_SET_HIGH  (0u == UARTdbg_uart_rx_wake_i2c_sda_spi_mosi_Read())

#elif (UARTdbg_RX_SDA_MOSI_PIN)
    #define UARTdbg_SET_I2C_SCL_DR(val) \
                            UARTdbg_uart_rx_i2c_sda_spi_mosi_Write(val)


    #define UARTdbg_SET_I2C_SCL_HSIOM_SEL(sel) \
                            UARTdbg_SET_HSIOM_SEL(UARTdbg_RX_SDA_MOSI_HSIOM_REG,  \
                                                           UARTdbg_RX_SDA_MOSI_HSIOM_MASK, \
                                                           UARTdbg_RX_SDA_MOSI_HSIOM_POS,  \
                                                           (sel))

    #define UARTdbg_WAIT_SCL_SET_HIGH  (0u == UARTdbg_uart_rx_i2c_sda_spi_mosi_Read())

#else
    #define UARTdbg_SET_I2C_SCL_DR(val)        do{ /* Does nothing */ }while(0)
    #define UARTdbg_SET_I2C_SCL_HSIOM_SEL(sel) do{ /* Does nothing */ }while(0)

    #define UARTdbg_WAIT_SCL_SET_HIGH  (0u)
#endif /* (UARTdbg_I2C_PINS) */

/* SCB I2C: sda signal */
#if (UARTdbg_I2C_PINS)
    #define UARTdbg_WAIT_SDA_SET_HIGH  (0u == UARTdbg_sda_Read())
/* Unconfigured SCB: sda signal */
#elif (UARTdbg_TX_SCL_MISO_PIN)
    #define UARTdbg_WAIT_SDA_SET_HIGH  (0u == UARTdbg_uart_tx_i2c_scl_spi_miso_Read())
#else
    #define UARTdbg_WAIT_SDA_SET_HIGH  (0u)
#endif /* (UARTdbg_MOSI_SCL_RX_PIN) */
#endif /* (UARTdbg_CY_SCBIP_V0) */

/* Clear UART wakeup source */
#if (UARTdbg_RX_SDA_MOSI_PIN)
    #define UARTdbg_CLEAR_UART_RX_WAKE_INTR        do{ /* Does nothing */ }while(0)
    
#elif (UARTdbg_RX_WAKE_SDA_MOSI_PIN)
    #define UARTdbg_CLEAR_UART_RX_WAKE_INTR \
            do{                                      \
                (void) UARTdbg_uart_rx_wake_i2c_sda_spi_mosi_ClearInterrupt(); \
            }while(0)

#elif(UARTdbg_UART_RX_WAKE_PIN)
    #define UARTdbg_CLEAR_UART_RX_WAKE_INTR \
            do{                                      \
                (void) UARTdbg_rx_wake_ClearInterrupt(); \
            }while(0)
#else
#endif /* (UARTdbg_RX_SDA_MOSI_PIN) */


/***************************************
* The following code is DEPRECATED and
* must not be used.
***************************************/

/* Unconfigured pins */
#define UARTdbg_REMOVE_MOSI_SCL_RX_WAKE_PIN    UARTdbg_REMOVE_RX_WAKE_SDA_MOSI_PIN
#define UARTdbg_REMOVE_MOSI_SCL_RX_PIN         UARTdbg_REMOVE_RX_SDA_MOSI_PIN
#define UARTdbg_REMOVE_MISO_SDA_TX_PIN         UARTdbg_REMOVE_TX_SCL_MISO_PIN
#ifndef UARTdbg_REMOVE_SCLK_PIN
#define UARTdbg_REMOVE_SCLK_PIN                UARTdbg_REMOVE_CTS_SCLK_PIN
#endif /* UARTdbg_REMOVE_SCLK_PIN */
#ifndef UARTdbg_REMOVE_SS0_PIN
#define UARTdbg_REMOVE_SS0_PIN                 UARTdbg_REMOVE_RTS_SS0_PIN
#endif /* UARTdbg_REMOVE_SS0_PIN */

/* Unconfigured pins */
#define UARTdbg_MOSI_SCL_RX_WAKE_PIN   UARTdbg_RX_WAKE_SDA_MOSI_PIN
#define UARTdbg_MOSI_SCL_RX_PIN        UARTdbg_RX_SDA_MOSI_PIN
#define UARTdbg_MISO_SDA_TX_PIN        UARTdbg_TX_SCL_MISO_PIN
#ifndef UARTdbg_SCLK_PIN
#define UARTdbg_SCLK_PIN               UARTdbg_CTS_SCLK_PIN
#endif /* UARTdbg_SCLK_PIN */
#ifndef UARTdbg_SS0_PIN
#define UARTdbg_SS0_PIN                UARTdbg_RTS_SS0_PIN
#endif /* UARTdbg_SS0_PIN */

#if (UARTdbg_MOSI_SCL_RX_WAKE_PIN)
    #define UARTdbg_MOSI_SCL_RX_WAKE_HSIOM_REG     UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_REG
    #define UARTdbg_MOSI_SCL_RX_WAKE_HSIOM_PTR     UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_REG
    #define UARTdbg_MOSI_SCL_RX_WAKE_HSIOM_MASK    UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_REG
    #define UARTdbg_MOSI_SCL_RX_WAKE_HSIOM_POS     UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_REG

    #define UARTdbg_MOSI_SCL_RX_WAKE_INTCFG_REG    UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_REG
    #define UARTdbg_MOSI_SCL_RX_WAKE_INTCFG_PTR    UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_REG

    #define UARTdbg_MOSI_SCL_RX_WAKE_INTCFG_TYPE_POS   UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_REG
    #define UARTdbg_MOSI_SCL_RX_WAKE_INTCFG_TYPE_MASK  UARTdbg_RX_WAKE_SDA_MOSI_HSIOM_REG
#endif /* (UARTdbg_RX_WAKE_SDA_MOSI_PIN) */

#if (UARTdbg_MOSI_SCL_RX_PIN)
    #define UARTdbg_MOSI_SCL_RX_HSIOM_REG      UARTdbg_RX_SDA_MOSI_HSIOM_REG
    #define UARTdbg_MOSI_SCL_RX_HSIOM_PTR      UARTdbg_RX_SDA_MOSI_HSIOM_PTR
    #define UARTdbg_MOSI_SCL_RX_HSIOM_MASK     UARTdbg_RX_SDA_MOSI_HSIOM_MASK
    #define UARTdbg_MOSI_SCL_RX_HSIOM_POS      UARTdbg_RX_SDA_MOSI_HSIOM_POS
#endif /* (UARTdbg_MOSI_SCL_RX_PIN) */

#if (UARTdbg_MISO_SDA_TX_PIN)
    #define UARTdbg_MISO_SDA_TX_HSIOM_REG      UARTdbg_TX_SCL_MISO_HSIOM_REG
    #define UARTdbg_MISO_SDA_TX_HSIOM_PTR      UARTdbg_TX_SCL_MISO_HSIOM_REG
    #define UARTdbg_MISO_SDA_TX_HSIOM_MASK     UARTdbg_TX_SCL_MISO_HSIOM_REG
    #define UARTdbg_MISO_SDA_TX_HSIOM_POS      UARTdbg_TX_SCL_MISO_HSIOM_REG
#endif /* (UARTdbg_MISO_SDA_TX_PIN_PIN) */

#if (UARTdbg_SCLK_PIN)
    #ifndef UARTdbg_SCLK_HSIOM_REG
    #define UARTdbg_SCLK_HSIOM_REG     UARTdbg_CTS_SCLK_HSIOM_REG
    #define UARTdbg_SCLK_HSIOM_PTR     UARTdbg_CTS_SCLK_HSIOM_PTR
    #define UARTdbg_SCLK_HSIOM_MASK    UARTdbg_CTS_SCLK_HSIOM_MASK
    #define UARTdbg_SCLK_HSIOM_POS     UARTdbg_CTS_SCLK_HSIOM_POS
    #endif /* UARTdbg_SCLK_HSIOM_REG */
#endif /* (UARTdbg_SCLK_PIN) */

#if (UARTdbg_SS0_PIN)
    #ifndef UARTdbg_SS0_HSIOM_REG
    #define UARTdbg_SS0_HSIOM_REG      UARTdbg_RTS_SS0_HSIOM_REG
    #define UARTdbg_SS0_HSIOM_PTR      UARTdbg_RTS_SS0_HSIOM_PTR
    #define UARTdbg_SS0_HSIOM_MASK     UARTdbg_RTS_SS0_HSIOM_MASK
    #define UARTdbg_SS0_HSIOM_POS      UARTdbg_RTS_SS0_HSIOM_POS
    #endif /* UARTdbg_SS0_HSIOM_REG */
#endif /* (UARTdbg_SS0_PIN) */

#define UARTdbg_MOSI_SCL_RX_WAKE_PIN_INDEX UARTdbg_RX_WAKE_SDA_MOSI_PIN_INDEX
#define UARTdbg_MOSI_SCL_RX_PIN_INDEX      UARTdbg_RX_SDA_MOSI_PIN_INDEX
#define UARTdbg_MISO_SDA_TX_PIN_INDEX      UARTdbg_TX_SCL_MISO_PIN_INDEX
#ifndef UARTdbg_SCLK_PIN_INDEX
#define UARTdbg_SCLK_PIN_INDEX             UARTdbg_CTS_SCLK_PIN_INDEX
#endif /* UARTdbg_SCLK_PIN_INDEX */
#ifndef UARTdbg_SS0_PIN_INDEX
#define UARTdbg_SS0_PIN_INDEX              UARTdbg_RTS_SS0_PIN_INDEX
#endif /* UARTdbg_SS0_PIN_INDEX */

#define UARTdbg_MOSI_SCL_RX_WAKE_PIN_MASK UARTdbg_RX_WAKE_SDA_MOSI_PIN_MASK
#define UARTdbg_MOSI_SCL_RX_PIN_MASK      UARTdbg_RX_SDA_MOSI_PIN_MASK
#define UARTdbg_MISO_SDA_TX_PIN_MASK      UARTdbg_TX_SCL_MISO_PIN_MASK
#ifndef UARTdbg_SCLK_PIN_MASK
#define UARTdbg_SCLK_PIN_MASK             UARTdbg_CTS_SCLK_PIN_MASK
#endif /* UARTdbg_SCLK_PIN_MASK */
#ifndef UARTdbg_SS0_PIN_MASK
#define UARTdbg_SS0_PIN_MASK              UARTdbg_RTS_SS0_PIN_MASK
#endif /* UARTdbg_SS0_PIN_MASK */

#endif /* (CY_SCB_PINS_UARTdbg_H) */


/* [] END OF FILE */
