/*******************************************************************************
* File Name: UARTdbg_SCBCLK.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_UARTdbg_SCBCLK_H)
#define CY_CLOCK_UARTdbg_SCBCLK_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void UARTdbg_SCBCLK_StartEx(uint32 alignClkDiv);
#define UARTdbg_SCBCLK_Start() \
    UARTdbg_SCBCLK_StartEx(UARTdbg_SCBCLK__PA_DIV_ID)

#else

void UARTdbg_SCBCLK_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void UARTdbg_SCBCLK_Stop(void);

void UARTdbg_SCBCLK_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 UARTdbg_SCBCLK_GetDividerRegister(void);
uint8  UARTdbg_SCBCLK_GetFractionalDividerRegister(void);

#define UARTdbg_SCBCLK_Enable()                         UARTdbg_SCBCLK_Start()
#define UARTdbg_SCBCLK_Disable()                        UARTdbg_SCBCLK_Stop()
#define UARTdbg_SCBCLK_SetDividerRegister(clkDivider, reset)  \
    UARTdbg_SCBCLK_SetFractionalDividerRegister((clkDivider), 0u)
#define UARTdbg_SCBCLK_SetDivider(clkDivider)           UARTdbg_SCBCLK_SetDividerRegister((clkDivider), 1u)
#define UARTdbg_SCBCLK_SetDividerValue(clkDivider)      UARTdbg_SCBCLK_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define UARTdbg_SCBCLK_DIV_ID     UARTdbg_SCBCLK__DIV_ID

#define UARTdbg_SCBCLK_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define UARTdbg_SCBCLK_CTRL_REG   (*(reg32 *)UARTdbg_SCBCLK__CTRL_REGISTER)
#define UARTdbg_SCBCLK_DIV_REG    (*(reg32 *)UARTdbg_SCBCLK__DIV_REGISTER)

#define UARTdbg_SCBCLK_CMD_DIV_SHIFT          (0u)
#define UARTdbg_SCBCLK_CMD_PA_DIV_SHIFT       (8u)
#define UARTdbg_SCBCLK_CMD_DISABLE_SHIFT      (30u)
#define UARTdbg_SCBCLK_CMD_ENABLE_SHIFT       (31u)

#define UARTdbg_SCBCLK_CMD_DISABLE_MASK       ((uint32)((uint32)1u << UARTdbg_SCBCLK_CMD_DISABLE_SHIFT))
#define UARTdbg_SCBCLK_CMD_ENABLE_MASK        ((uint32)((uint32)1u << UARTdbg_SCBCLK_CMD_ENABLE_SHIFT))

#define UARTdbg_SCBCLK_DIV_FRAC_MASK  (0x000000F8u)
#define UARTdbg_SCBCLK_DIV_FRAC_SHIFT (3u)
#define UARTdbg_SCBCLK_DIV_INT_MASK   (0xFFFFFF00u)
#define UARTdbg_SCBCLK_DIV_INT_SHIFT  (8u)

#else 

#define UARTdbg_SCBCLK_DIV_REG        (*(reg32 *)UARTdbg_SCBCLK__REGISTER)
#define UARTdbg_SCBCLK_ENABLE_REG     UARTdbg_SCBCLK_DIV_REG
#define UARTdbg_SCBCLK_DIV_FRAC_MASK  UARTdbg_SCBCLK__FRAC_MASK
#define UARTdbg_SCBCLK_DIV_FRAC_SHIFT (16u)
#define UARTdbg_SCBCLK_DIV_INT_MASK   UARTdbg_SCBCLK__DIVIDER_MASK
#define UARTdbg_SCBCLK_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_UARTdbg_SCBCLK_H) */

/* [] END OF FILE */
