/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>

#include <debug.h>
#include <stdio.h>
#include <math.h>
#include <PatternFunctions.h>
const double  factor512 = 0.0019607843137254901960;
const double  halffactor512 = 0.00390625;

void calc_sine(uint8 *samplevalues, uint8 minval, uint8 maxval )
{
    uint8 gain = maxval - minval;
    for( int n=0; n < SAMPLELENGTH; ++n)    
    {  
        float e = sin( 2*PI *factor512*n);
        samplevalues[n] = (0x80 + 0x80 * e);
    }   
}

void calc_square(uint8 *samplevalues,uint8 minval, uint8 maxval, uint8 dutycycle)
{
    uint8 lval=0;
    if (dutycycle>100)
    {
        dutycycle = 50;
    }
    for (int i=0;i<SAMPLELENGTH;i++)
    {
        if(i<SAMPLELENGTH*(dutycycle*0.01))
        {   
            
            samplevalues[i] = maxval;
        }
    
        else
        {
            samplevalues[i] = minval;
        }
    }
}    
    
void calc_triangle(uint8 *samplevalues, uint8 minval, uint8 maxval)
{
    uint8 lval=0;
    uint8 gain = maxval - minval;
    //minval = offset  
    //((1/256 * gain * nsample)+minval)
    for (int i=0;i<SAMPLELENGTH;i++)
    {
        if(i<SAMPLELENGTH/2)
        {   
            
            samplevalues[i] = (halffactor512*gain * lval++)+minval;
        }
    
        else if (lval >= 0)
        {
            samplevalues[i] = (halffactor512*gain * lval--)+minval;
        }
    }
}

void calc_On(uint8 *samplevalues, uint8 minval, uint8 maxval)
{
    for( int n=minval; n < SAMPLELENGTH; ++n )
    {
        samplevalues[n] = maxval;
    }
}

void calc_off(uint8 *samplevalues )
{
    for( int n=0; n < SAMPLELENGTH; ++n )
    {
        samplevalues[n] = 0;
    }
}


void calc_sawtooth(uint8 *samplevalues, uint8 minval, uint8 maxval)
{
    uint8 lval=minval,hval=minval;
    for (int i=0;i<SAMPLELENGTH;i++)
    {
        if(i<SAMPLELENGTH/2)
        {   
            if(lval > maxval)
                samplevalues[i] = maxval;
            else
                samplevalues[i] = lval++;
        }
    
        else 
        {
            if(lval > maxval)
                samplevalues[i] = maxval;
            else
                samplevalues[i] = hval++;
        }
    }
     
}   




/* [] END OF FILE */
