/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include <debug.h>
#include <stdio.h>
#include <StatesHandler.h>
#include <main.h>


uint8 PropelProgramCounter=0;
uint8 VibratorProgramCounter=0;
uint8 LEDProgramCounter=0;
 
static const char *InternStates_e_text[] = {
    "IDLE", "PROGRAM_RUNNING", "OUTPUT_OFF"};

void propinternstates(){
        
    tEvent_e *ExeEvent = &PropExeEvent;
    tInternStates_e *InternStates = &PropInternStates;
    tInternStates_e *NewState = &NewPropState;
    
      if (*InternStates!= *NewState)
        {
            DBG_PRINTF("PropInternStates: %s",InternStates_e_text[PropInternStates]);
        }
       
        switch(*InternStates)
        {
             
        case IDLE:
            if (*ExeEvent == START_PROGRAM)
            { 
                PropelProgramCounter = 0;
                
                programstackhandler_Propel();
                *NewState = PROGRAM_RUNNING; 
            }
           if (*ExeEvent == STOP_PROGRAM)
                *NewState = OUTPUT_OFF;
            
            break;
        case PROGRAM_RUNNING:
            if (*ExeEvent == NEXT_FRAME)
            {
                programstackhandler_Propel();
                *NewState = PROGRAM_RUNNING;
            }
            if (*ExeEvent == STOP_PROGRAM)
                *NewState = OUTPUT_OFF; 
            break;

        case OUTPUT_OFF:
            propellerStopAndClear();
            *NewState = IDLE;
         
            break;
            
            default:
            break;
        }
            if (*InternStates!= *NewState){
                AttributeHandle.attrHandle = CYBLE_PACEDEV_SERVICE_GETSTATE_CHAR_HANDLE;
	            //AttributeHandle.value.val = (uint8*)&NewPropState;
	            AttributeHandle.value.val = (uint8*)NewState;
                AttributeHandle.value.len = 2;
                CyBle_GattsWriteAttributeValue(&AttributeHandle, FALSE, &cyBle_connHandle, FALSE);
                //CyBle_GattcWriteCharacteristicValue(cyBle_connHandle,&AttributeHandle);
            }
        *InternStates = *NewState;
            
            
        *ExeEvent = CLEAR_EVENT;
}
void vibratorinternstates(){
    
      tEvent_e *ExeEvent = &VibraExeEvent;
    tInternStates_e *InternStates = &VibraInternStates;
     tInternStates_e *NewState = &NewVibraState;
      if (*InternStates!= *NewState)
        {
            DBG_PRINTF("vibratorinternstates: %s",InternStates_e_text[*InternStates]);
        }
       
        switch(*InternStates)
        {
             
        case IDLE:
            if (*ExeEvent == START_PROGRAM)
            { 
                VibratorProgramCounter = 0;
                programstackhandler_Vibrator();
                *NewState = PROGRAM_RUNNING; 
            }
           if (*ExeEvent == STOP_PROGRAM)
                *NewState = OUTPUT_OFF;
            
            break;
        case PROGRAM_RUNNING:
            if (*ExeEvent == NEXT_FRAME)
            {
                programstackhandler_Vibrator();
                *NewState = PROGRAM_RUNNING;
            }
            if (*ExeEvent == STOP_PROGRAM)
                *NewState = OUTPUT_OFF; 
            break;

        case OUTPUT_OFF:
            vibratorStopAndClear();

            *NewState = IDLE;
         
            break;
            
            default:
            break;
        }
            if (*InternStates!= *NewState){
                AttributeHandle.attrHandle = CYBLE_PACEDEV_SERVICE_GETSTATE_CHAR_HANDLE;
	            AttributeHandle.value.val = (uint8*)NewState;
	            AttributeHandle.value.len = 2;
                CyBle_GattsWriteAttributeValue(&AttributeHandle, FALSE, &cyBle_connHandle, FALSE);
                //CyBle_GattcWriteCharacteristicValue(cyBle_connHandle,&AttributeHandle);
            }
        *InternStates = *NewState;
            
            
        *ExeEvent = CLEAR_EVENT;
}
void ledinternstates(){
    
    tEvent_e *ExeEvent = &LedExeEvent;
    tInternStates_e *InternStates = &LedInternStates;
    tInternStates_e *NewState = &NewLedState;
      if (*InternStates!= *NewState)
        {
            DBG_PRINTF("ledinternstates: %s",InternStates_e_text[*InternStates]);
        }
       
        switch(*InternStates)
        {
             
        case IDLE:
            if (*ExeEvent == START_PROGRAM)
            { 
                LEDProgramCounter = 0;
                programstackhandler_Led();
                *NewState = PROGRAM_RUNNING; 
            }
           if (*ExeEvent == STOP_PROGRAM)
                *NewState = OUTPUT_OFF;
            break;
        
        case PROGRAM_RUNNING:
            if (*ExeEvent == NEXT_FRAME)
            {
                programstackhandler_Led();
                *NewState = PROGRAM_RUNNING;
            }
            if (*ExeEvent == STOP_PROGRAM)
                *NewState = OUTPUT_OFF; 
            break;

        case OUTPUT_OFF:
            ledStopAndClear();

            *NewState = IDLE;
         
            break;
            
            default:
            break;
        }
            if (*InternStates!=  *NewState){
                AttributeHandle.attrHandle = CYBLE_PACEDEV_SERVICE_GETSTATE_CHAR_HANDLE;
	           // AttributeHandle.value.val = (uint8*)InternStates;
	            AttributeHandle.value.val = (uint8*)NewState;
                AttributeHandle.value.len = 2;
                CyBle_GattsWriteAttributeValue(&AttributeHandle, FALSE, &cyBle_connHandle, FALSE);
                //CyBle_GattcWriteCharacteristicValue(cyBle_connHandle,&AttributeHandle);
            }
        *InternStates = *NewState;
           
        *ExeEvent = CLEAR_EVENT;
}


/* [] END OF FILE */
