/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include "common.h"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "options.h"
#include "cytypes.h"
#include "debug.h"
#include "common.h"
#include "StatesHandler.h"
#include "PatternFunctions.h"
#include "main.h"

#define false 0
#define true 1

#define  FirmWareVerison "0.0.4"



uint8 pattern_index=254;
uint32 rgb_period_cnt=0;
uint8 pattern_rgbrepeat=0;
uint32 current_period=0;


//*SERIAL UARTS*/
char strMsg1[64]; //output UART buffer

   





/*******************************************************************************
* Function Name: PrintProjectHeader()
********************************************************************************
* Summary:
*  Prints project header to UART.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/






    // BLE Stack Handler
void BleCallBack(uint32 event, void* eventParam)
{
    CYBLE_GATTS_WRITE_REQ_PARAM_T *wrReqParam;
 //   CYBLE_GATTS_CHAR_VAL_READ_REQ_T *rdReqParam;
    switch ( event)
    {
        case CYBLE_EVT_STACK_ON:
        case CYBLE_EVT_GAP_DEVICE_DISCONNECTED: // disconnect
            CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);
            Clock_2_SetFractionalDividerRegister(0xFFFF,0);
            LED_blue_Write(0xFF);
            pwm_blue_Start();
        break;
        
        case CYBLE_EVT_GATT_CONNECT_IND: // connect
            Clock_2_SetFractionalDividerRegister(0xFF,0);
            pwm_blue_WriteCompare(0);
        break;
        
        //handle a write request
        case CYBLE_EVT_GATTS_WRITE_REQ:
            wrReqParam = (CYBLE_GATTS_WRITE_CMD_REQ_PARAM_T *) eventParam;

            
    
    

           
            //Control regsiter mode Propeller
            if( wrReqParam->handleValPair.attrHandle == CYBLE_PACEDEV_SERVICE_CONTROLREGISTER_PROPELLER_CHAR_HANDLE)
            {
                //write if write is allowed
                if(CYBLE_GATT_ERR_NONE == CyBle_GattsWriteAttributeValue(&wrReqParam->handleValPair,0, &cyBle_connHandle, CYBLE_GATT_DB_PEER_INITIATED))
                    {
                           CtrlMode_prop =wrReqParam->handleValPair.value.val[0];
                        
                       // update_RGB(wrReqParam->handleValPair.value.val[0],wrReqParam->handleValPair.value.val[1],wrReqParam->handleValPair.value.val[2]);
                        CyBle_GattsWriteRsp(cyBle_connHandle); //requred response for a write to the gatt db
                    }
            }     
            //Control regsiter mode Vibrator
            if( wrReqParam->handleValPair.attrHandle == CYBLE_PACEDEV_SERVICE_CONTROLREGISTER_VIBRATOR_CHAR_HANDLE)
            {
                //write if write is allowed
                if(CYBLE_GATT_ERR_NONE == CyBle_GattsWriteAttributeValue(&wrReqParam->handleValPair,0, &cyBle_connHandle, CYBLE_GATT_DB_PEER_INITIATED))
                    {
                           CtrlMode_vibra =wrReqParam->handleValPair.value.val[0];
                           CyBle_GattsWriteRsp(cyBle_connHandle); //requred response for a write to the gatt db
                    }
            }   
            //Control regsiter mode LED
            if( wrReqParam->handleValPair.attrHandle == CYBLE_PACEDEV_SERVICE_CONTROLREGISTER_LED_CHAR_HANDLE)
            {
                //write if write is allowed
                if(CYBLE_GATT_ERR_NONE == CyBle_GattsWriteAttributeValue(&wrReqParam->handleValPair,0, &cyBle_connHandle, CYBLE_GATT_DB_PEER_INITIATED))
                    {
                           CtrlMode_led=wrReqParam->handleValPair.value.val[0];
                           CyBle_GattsWriteRsp(cyBle_connHandle); //requred response for a write to the gatt db
                           DBG_PRINTF("CtrlMode_led change: %d",CtrlMode_led);
                    }
            } 


            //cyreset
         
       
                                   //Bootloader enable
         
            case CYBLE_EVT_GATTS_READ_CHAR_VAL_ACCESS_REQ:
/*     if (rdReqParam->attrHandle == CYBLE_PACEDEV_SERVICE_GETSTATE_CHAR_HANDLE) 
                {

                    }
                break;*/
            default:
            break;
    }
    
}





int main (void)
{   
    CYBLE_API_RESULT_T apiResult;
    uint8 ptestMode=255;
    uint8 tesmodecnt = 0;
    uint8 hwtestmode_flag = 0;
    
    const char8 serialNumber[] = "2028-000002";
    CyBle_DissSetCharacteristicValue(CYBLE_DIS_SERIAL_NUMBER   , sizeof(serialNumber), (uint8*)serialNumber);
    CyBle_DissSetCharacteristicValue(CYBLE_DIS_FIRMWARE_REV   , sizeof(FirmWareVerison), (uint8*)FirmWareVerison);
    /* Print project header via UART, for debug purpose */
    CyGlobalIntEnable;
    hwtestmode_flag = 1;
    #if !defined(__ARMCC_VERSION)
      //  InitializeBootloaderSRAM();
    #endif

   
    Disconnect_LED_Write(LED_OFF);
 /* Checks if Self Project Image is updated and Runs for the First time */
//    AfterImageUpdate();

    apiResult = CyBle_Start(BleCallBack);

    if(apiResult != CYBLE_ERROR_OK)
    {
        /* BLE stack initialization failed, check your configuration */
        CYASSERT(0);
    }


    pwm_Vibrator_Start();

    pwm_blue_Start();




    ptestMode = ptestMode;
    
    for(;;)
    {

    
        /* If key press event was detected - debounce it and switch 
        to bootloader emulator mode */
        if (SW2_Read() == 0u)
        {
            CyDelay(500u);
            if (SW2_Read() == 0u)
            {
                CyDelay(500u);

                while (SW2_Read() == 0u)
                    {
                   
                        /* Wait for button to be released */
                    }
                
                //Switch to the Stack project, which enables OTA service
           //     Bootloadable_SetActiveApplication(0);
           //     Bootloadable_Load();
           //     CySoftwareReset();
            }
        }

        static uint8 toggleTimeout = 0;
        CYBLE_BLESS_STATE_T blessState;
        uint8 intrStatus;
                
        CyBle_ProcessEvents();
                /* Update Alert Level value on the blue LED */


        /* Configure BLESS in Deep-Sleep mode */
        CyBle_EnterLPM(CYBLE_BLESS_DEEPSLEEP);
        
        /* Prevent interrupts while entering system low power modes */
        intrStatus = CyEnterCriticalSection();
        
        /* Get the current state of BLESS block */
        blessState = CyBle_GetBleSsState();
        
        /* If BLESS is in Deep-Sleep mode or the XTAL oscillator is turning on, 
         * then PSoC 4 BLE can enter Deep-Sleep mode (1.3uA current consumption) */
        if(blessState == CYBLE_BLESS_STATE_ECO_ON || 
            blessState == CYBLE_BLESS_STATE_DEEPSLEEP)
        {
          //  CySysPmDeepSleep();
        }
        else if(blessState != CYBLE_BLESS_STATE_EVENT_CLOSE)
        {
            /* If BLESS is active, then configure PSoC 4 BLE system in 
             * Sleep mode (~1.6mA current consumption) */
           // CySysPmSleep();
        }
        else
        {
            /* Keep trying to enter either Sleep or Deep-Sleep mode */    
        }
        CyExitCriticalSection(intrStatus);
        
        /* BLE link layer timing interrupt will wake up the system from Sleep 
         * and Deep-Sleep modes */
        
   


    }
    DBG_PRINTF("ERROR MAIN LOOP BREAK");
}

