/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include "cytypes.h"

#if !defined(MAIN_H)
#define MAIN_H
#define FALSE                               (0)
#define ALL_OFF                             (0) 
#define NO                                  (0u)
#define YES                                 (1u)
CYBLE_GATT_HANDLE_VALUE_PAIR_T AttributeHandle;   


extern void InitializeBootloaderSRAM(void);
extern volatile uint32 mainTimer;

void AppCallBack(uint32 event, void* eventParam);
typedef  enum  
    {
     PROPELLER=0,
     VIBRATOR=1,
     LED=2,
    }tOutputDevices_e;
    
typedef  enum  
    {
     IDLE=0,
     PROGRAM_RUNNING=1,
     OUTPUT_OFF=2,
     STOPPED = 255
    }tInternStates_e;
//Internal StatesProp 
    
    typedef  enum  
    {
     CLEAR_EVENT=0,
     START_PROGRAM,   
     NEXT_FRAME,
     STOP_PROGRAM,
    }tEvent_e;
    
void SetEvent(tEvent_e *, tEvent_e);

//ControlReg States 
    
    typedef  enum  
    {
     IDLE_STATE=0,
     SIMPLE_PWM_START,
     SIMPLE_TRIANGLE_START,
     SIMPLE_PWM_STOP,
     SIMPLE_SINE_START = 4,
     RUN_LASTFRAME_ENTERED=5,
     CLEAR_ALL_FRAMES=6,
     START_PROGRAM_EXECUTION = 7,  
     STOP_PROGRAM_EXECUTION = 8,
    }tCtrlMode_e;

    
tInternStates_e PropInternStates,VibraInternStates,LedInternStates,NewPropState,NewVibraState,NewLedState;   
tEvent_e PropExeEvent, VibraExeEvent, LedExeEvent; 
tCtrlMode_e CtrlMode_prop,  CtrlMode_vibra, CtrlMode_led;

    

extern void programstackhandler_Propel();
extern void programstackhandler_Vibrator();
extern void programstackhandler_Led();

extern void propellerStopAndClear();
extern void vibratorStopAndClear();
extern void ledStopAndClear(); 
void interrupt_led_sample();
void interrupt_propeller_sample();
void interrupt_vibra_sample();


#endif /* MAIN_H */


/* [] END OF FILE */

